clear
set obs 10000
set seed 280352
gen Gaussian = .                      
gen skewness = . 
gen kurtosis = . 

qui forval i = 1/10000 { 
	noi di `i' 
	replace Gau = invnorm(uniform()) in 1/100 
	su G in 1/100, detail 
	replace skewness = r(skewness) in `i' 
	replace kurtosis = r(kurtosis) in `i' 
} 

scatter kurtosis skewness, ms(oh) msize(*0.5) yla(, ang(h)) ///
xli(0) yli(3) subtitle(10000 samples of size 100 from Gaussian) saving(skewkurt_g, asis replace) 
more 
qnorm skewness, saving(skew_g, asis replace) 
more 
qnorm kurtosis, saving(kurt_g, asis replace) 

