clear
set obs 10000
set seed 280352
gen Gaussian = .  
gen t3 = . 
gen t4 = . 

qui forval i = 1/10000 { 
	noi di `i' 
	replace Gau = invnorm(uniform()) in 1/100
	lmoments2 G in 1/100 
	replace t3 = r(t_3) in `i' 
	replace t4 = r(t_4) in `i' 
} 

scatter t4 t3, ms(oh) msize(*0.5) yla(, ang(h)) ///
xli(0) yli(0.123) subtitle(10000 samples of size 100 from Gaussian) ///
yti(t_4) xti(t_3) saving(t3t4_g, asis replace) 
more
qnorm t3, saving(t3_g, asis replace) yti(t_3) 
more 
qnorm t4, saving(t4_g, asis replace) yti(t_4) 

